

close all;

mask=zeros(32,32,32);
mask( 2:end-1,2:end-1,2:end-1 )=1;

% degrees C (Gaussian initial temp.  distri for analytical solution)
dx=0.005; dy=0.005; dz=0.005;
xs=([1:32]'-16)*dx; ys=([1:32]'-16)*dy; zs=([1:32]'-16)*dz;
[xxs yys zzs]=ndgrid(xs,ys,zs);
sig0=[0.003;0.003;0.003];
T0=1e-7/( sig0(1)*sig0(2)*sig0(3) ).*exp( -xxs.^2/(2*sig0(1)^2) - yys.^2/(2*sig0(2)^2) - zzs.^2/(2*sig0(3)^2) );

ntimes=100;  % seconds
rho=1000 * mask;  % kg/m^3
C=4179 * mask;  % J/(kg*degree)
K=0.58 * mask;  % W/(m*degree)
rho_blood=1060;  % kg/m^3
Wb=zeros(size(mask));
Cb=3617;  % J/(kg*degree)
Tb=37;  % degree
Q=zeros(size(mask));
save 'TestDatasSet_1.mat' 'T0' 'rho' 'C' 'K' 'Wb' 'Cb' 'Tb' 'Q' 'sig0' 'xxs' 'yys' 'zzs';

to_disp1=[ squeeze(T0(:,:,end/2)) squeeze(T0(:,end/2,:)) squeeze(T0(end/2,:,:)) ];
to_disp2=[ squeeze(rho(:,:,end/2)) squeeze(rho(:,end/2,:)) squeeze(rho(end/2,:,:)) ];
to_disp3=[ squeeze(C(:,:,end/2)) squeeze(C(:,end/2,:)) squeeze(C(end/2,:,:)) ];
to_disp4=[ squeeze(K(:,:,end/2)) squeeze(K(:,end/2,:)) squeeze(K(end/2,:,:)) ];
to_disp5=[ squeeze(Wb(:,:,end/2)) squeeze(Wb(:,end/2,:)) squeeze(Wb(end/2,:,:)) ];
to_disp6=[ squeeze(Q(:,:,end/2)) squeeze(Q(:,end/2,:)) squeeze(Q(end/2,:,:)) ];

f1=figure;
imagesc(to_disp1); axis image; axis off; colormap(hot); colorbar;
title('T0 [degrees C]');

f2=figure;
imagesc(to_disp2); axis image; axis off; colormap(hot); colorbar;
title('Density [kg/m^3]');

f3=figure;
imagesc(to_disp3); axis image; axis off; colormap(hot); colorbar;
title('Specific heat (C) [J/(kg*degree)]');

f4=figure;
imagesc(to_disp4); axis image; axis off; colormap(hot); colorbar;
title('Thermal conductivity (K) [W/(m*degree)]');

f5=figure;
imagesc(to_disp5); axis image; axis off; colormap(hot); colorbar;
title('Perfusion (Wb) [kg/(s*m^3)]');

f6=figure;
imagesc(to_disp6); axis image; axis off; colormap(hot); colorbar;
title('Heat rate generation (Q) [W/m^3]');


















