

function ind_gn_global=pbhs_create_ghost_nodes(mask,ind_b_global)
% function ind_gn_global=pbhs_create_ghost_nodes(mask,ind_b_global)

fprintf('Creating ghost nodes ');

[nx ny nz]=size(mask);

[ind_b2_x ind_b2_y ind_b2_z]=ind2sub(size(mask),ind_b_global);

npix=0;
block_size=1000;  % memory management by blocks
tot_size=block_size;
ind_gn_global=zeros(block_size,1);

sbuf=[];
for i=1:size(ind_b_global,1)  % loop over boundary voxels

    if mod(i,100)==0
        for j=1:size(sbuf,2)
            fprintf('\b');
        end
        sbuf=sprintf('[%d/%d]',i,size(ind_b_global,1));
        fprintf(sbuf);
    end
    
    ind_=[];
    x=ind_b2_x(i);
    y=ind_b2_y(i);
    z=ind_b2_z(i);
    
    ind=x-1 + (y-1)*nx + (z-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end    
    ind=x+1 + (y-1)*nx + (z-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end
    
    ind=x + (y-1-1)*nx + (z-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end    
    ind=x + (y+1-1)*nx + (z-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end

    ind=x + (y-1)*nx + (z-1-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end    
    ind=x + (y-1)*nx + (z+1-1)*nx*ny;
    if mask(ind)==0
        ind_=[ind_ ; ind];
    end
   
    while npix+size(ind_,1) > tot_size  % pad array until it is big enough to hold the content of the newly found ghost nodes
        ind_gn_global=padarray(ind_gn_global,[block_size,0],'post');
        tot_size=tot_size + block_size;
    end
    
    ind_gn_global( npix+1:npix+size(ind_,1) )=ind_;
    npix=npix + size(ind_,1);
    
end

ind_gn_global=ind_gn_global(1:npix,1);

fprintf('\n');




