


function L=pbhs_create_laplacian_operator(mask,DX,kmap)
% function L=pbhs_create_laplacian_operator(mask,DX,kmap)

[nx ny nz]=size(mask);
npix_tot=nx*ny*nz;

ind=find(mask>0);  % all pixels
[indx indy indz]=ind2sub([nx ny nz],ind);
npix=size(ind,1);

fprintf('Computing Fourier operator ');
L_full=sparse(npix_tot,npix_tot);

sbuf=[];

% -x term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[1/6]');
fprintf(sbuf);

a=indx-1; b=indy; c=indz;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x+1 , ind2_y ,ind2_z );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(1)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(1)^2,@plus );  % diagonal

% +x term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[2/6]');
fprintf(sbuf);

a=indx+1; b=indy; c=indz;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x-1 , ind2_y ,ind2_z );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(1)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(1)^2,@plus );  % diagonal


% -y term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[3/6]');
fprintf(sbuf);

a=indx; b=indy-1; c=indz;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x , ind2_y+1 ,ind2_z );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(2)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(2)^2,@plus );  % diagonal

% +y term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[4/6]');
fprintf(sbuf);

a=indx; b=indy+1; c=indz;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x , ind2_y-1 ,ind2_z );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(2)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(2)^2,@plus );  % diagonal

% -z term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[5/6]');
fprintf(sbuf);

a=indx; b=indy; c=indz-1;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x , ind2_y ,ind2_z+1 );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(3)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(3)^2,@plus );  % diagonal

% +z term (Laplacian)
for j=1:size(sbuf,2)
    fprintf('\b');
end
sbuf=sprintf('[6/6]');
fprintf(sbuf);

a=indx; b=indy; c=indz+1;
tmp=find( a>0 & a<=nx & b>0 & b<=ny & c>0 & c<=nz );
a=a(tmp); b=b(tmp); c=c(tmp);
ind2=sub2ind( [nx ny nz],a,b,c );
ind2=ind2( find(mask(ind2)>0) ); % only retain those indices that are in the mask
[ind2_x ind2_y ind2_z]=ind2sub( [nx ny nz],ind2 );
ind3=sub2ind( [nx ny nz], ind2_x , ind2_y ,ind2_z-1 );

L_full=setsparse( L_full,ind2,ind3,(kmap(ind2)+kmap(ind3))/2/DX(3)^2,@plus );  % off diagonal
L_full=setsparse( L_full,ind3,ind3,-(kmap(ind2)+kmap(ind3))/2/DX(3)^2,@plus );  % diagonal

L=sparse(npix,npix);
L=L_full(ind,ind);

fprintf('\n');





