

function ind_b=pbhs_detect_pixels_boundary(mask)
% function ind_b=pbhs_detect_pixels_boundary(mask)

img_b=zeros(size(mask));

fprintf('Detecting pixel boundaries ');
sbuf=[];

% loop in x
for i=1:size(mask,1)
    
    img=squeeze(mask(i,:,:));
    
    if mod(i,10)
        for j=1:size(sbuf,2)
            fprintf('\b');
        end
        sbuf=sprintf('[%d/%d]',i,sum(size(mask),2));
        fprintf(sbuf);
    end
    
    mask_b=bwboundaries(img);
    
    for j=1:size(mask_b)  % loop on all labels, i.e. holes within the object are interpreted as boundary pixels
        ind=sub2ind(size(img),mask_b{j}(:,1),mask_b{j}(:,2));
        tmp=zeros(size(img));
        tmp(ind)=1;
        img_b( i,:,: )=tmp;
    end
    
end


% loop in y
for i=1:size(mask,2)
    
    img=squeeze(mask(:,i,:));
    
    if 1
        for j=1:size(sbuf,2)
            fprintf('\b');
        end
        sbuf=sprintf('[%d/%d]',i+size(mask,1),sum(size(mask),2));
        fprintf(sbuf);
    end
    
    mask_b=bwboundaries(img);
    
    for j=1:size(mask_b)  % loop on all labels, i.e. holes within the object are interpreted as boundary pixels
        ind=sub2ind(size(img),mask_b{j}(:,1),mask_b{j}(:,2));
        tmp=zeros(size(img));
        tmp(ind)=1;
        img_b( :,i,: )=img_b( :,i,: ) + reshape(tmp,size(img_b( :,i,: )));
    end
    
end


% loop in z
for i=1:size(mask,3)    
    img=squeeze(mask(:,:,i));
    
    if 1
        for j=1:size(sbuf,2)
            fprintf('\b');
        end
        sbuf=sprintf('[%d/%d]',i+size(mask,1)+size(mask,2),sum(size(mask),2));
        fprintf(sbuf);
    end
    
    mask_b=bwboundaries(img);
    
    for j=1:size(mask_b)  % loop on all labels, i.e. holes within the object are interpreted as boundary pixels
        ind=sub2ind(size(img),mask_b{j}(:,1),mask_b{j}(:,2));
        tmp=zeros(size(img));
        tmp(ind)=1;
        img_b( :,:,i )=img_b( :,:,i ) + reshape(tmp,size(img_b( :,:,i )));
    end
    
end

fprintf('\n');

ind_b=find(img_b>0);  % list of boundary pizels in the global image frame










