
clear;

close all;

load TestDatasSet_1;

options.KeepAllTempMaps=0;
options.DisplayTemp=1;
options.UsePreconditioner=1;
options.LUPreconDropTol=0.05;
options.BoundaryConditionType=1;  % Dirichlet
options.BoundaryTemperature=0; 
options.TimeStep=-1;  % set to Von Neumann
options.UniformThermalCondMap=1;

duration=3000;  % seconds

% numerical solution
[T times]=pbhs_solve(T0,duration,[0.005;0.005;0.005],rho,C,K,Wb,Cb,Tb,Q,options);

% analytical solution
alpha=max(K(:))/(max(rho(:))*max(C(:)));
sig_an=sqrt( 2*alpha*times(end) + sig0.^2 );

T_an=1e-7/( sig_an(1)*sig_an(2)*sig_an(3) ) .* exp( -xxs.^2/(2*sig_an(1)^2) - yys.^2/(2*sig_an(2)^2) - zzs.^2/(2*sig_an(3)^2) );

to_disp1=[ squeeze(T(:,:,end/2)) squeeze(T(:,end/2,:)) squeeze(T(end/2,:,:)) ];
to_disp2=[ squeeze(T_an(:,:,end/2)) squeeze(T_an(:,end/2,:)) squeeze(T_an(end/2,:,:)) ];

f=figure;
subplot(2,1,1); imagesc(to_disp1); axis image; axis off; colormap(hot); colorbar; title('Numerical solution [degrees C]');
subplot(2,1,2); imagesc(to_disp2); axis image; axis off; colormap(hot); colorbar; title('Analytical solution [degrees C]');


















