
clear;

close all;

load TestDatasSet_2;

options.KeepAllTempMaps=0;
options.DisplayTemp=1;
options.BoundaryTemperature=0;
options.TimeStep=100;
options.UsePreconditioner=1;
options.LUPreconDropTol=0.05;

ntimes=10;

% numerical solution #1
options.UniformThermalCondMap=1;
K_unif=0.58 * (rho>0);
[T times]=pbhs_solve(T0,ntimes,[0.005;0.005;0.005],rho,C,K_unif,Wb,Cb,Tb,Q,options);
tmp=zeros(size(rho));
tmp(find(rho>0))=T;
T_wrong=tmp;

% numerical solution #2
options.UniformThermalCondMap=0;

[T times]=pbhs_solve(T0,ntimes,[0.005;0.005;0.005],rho,C,K,Wb,Cb,Tb,Q,options);
tmp=zeros(size(rho));
tmp(find(rho>0))=T;
T_right=tmp;

to_disp1=[ squeeze(T_wrong(:,:,end/2)) squeeze(T_wrong(:,end/2,:)) squeeze(T_wrong(end/2,:,:)) ];
to_disp2=[ squeeze(T_right(:,:,end/2)) squeeze(T_right(:,end/2,:)) squeeze(T_right(end/2,:,:)) ];

err=T_wrong - T_right;
to_disp3=[ squeeze(err(:,:,end/2)) squeeze(err(:,end/2,:)) squeeze(err(end/2,:,:)) ];

f=figure;
subplot(3,1,1); imagesc(to_disp1); axis image; axis off; colormap(hot); colorbar; title('Wrong solution [degrees C]');
subplot(3,1,2); imagesc(to_disp2); axis image; axis off; colormap(hot); colorbar; title('Right solution [degrees C]');
subplot(3,1,3); imagesc(to_disp3); axis image; axis off; colormap(hot); colorbar; title('Wrong-right solution [degrees C]');


















