




close all;

mask=zeros(32,32);

x=[1:32]'-16;
[xxs yys]=ndgrid(x,x);
rrs=sqrt( xxs.^2+yys.^2 );

mask=double(rrs<8);
ind=find(mask>0);
npix=size(ind,1);
[indx indy]=ind2sub(size(mask),ind);

L=sparse(npix,npix);

% explicit
tmp=zeros(size(mask));
for i=1:npix
    tmp(:)=0;
    
    tmp( indx(i)-1:indx(i)+1,indy(i)-1:indy(i)+1 )=[0   1  0 ;
                                                    1  -4  1 ;
                                                    0   1  0 ];
    L(:,i)=sparse(tmp(ind));
end

figure;
imagesc(L); colorbar;

% faster
npix_tot=32^2;
L2_full=sparse(npix_tot,npix_tot);

% -x term
ind2=indx-1 + 32*(indy-1);
ind2_=find( mask(ind2)>0 );
ind2=ind2(ind2_);  % only retain those indices that are in the mask
[ind2x ind2y]=ind2sub( [32 32],ind2 );
ind3=ind2x+1 + 32*(ind2y-1);
L2_full( sub2ind([npix_tot npix_tot],ind2,ind3) )=1;

% +x term
ind2=indx+1 + 32*(indy-1);
ind2_=find( mask(ind2)>0 );
ind2=ind2(ind2_);  % only retain those indices that are in the mask
[ind2x ind2y]=ind2sub( [32 32],ind2 );
ind3=ind2x-1 + 32*(ind2y-1);
L2_full( sub2ind([npix_tot npix_tot],ind2,ind3) )=1;

% -y term
ind2=indx + 32*(indy-1-1);
ind2_=find( mask(ind2)>0 );
ind2=ind2(ind2_);  % only retain those indices that are in the mask
[ind2x ind2y]=ind2sub( [32 32],ind2 );
ind3=ind2x + 32*(ind2y+1-1);
L2_full( sub2ind([npix_tot npix_tot],ind2,ind3) )=1;

% +y term
ind2=indx + 32*(indy+1-1);
ind2_=find( mask(ind2)>0 );
ind2=ind2(ind2_);  % only retain those indices that are in the mask
[ind2x ind2y]=ind2sub( [32 32],ind2 );
ind3=ind2x + 32*(ind2y-1-1);
L2_full( sub2ind([npix_tot npix_tot],ind2,ind3) )=1;

L2=sparse(npix,npix);
L2=L2_full( ind,ind );

% diagonal term
L2( ([1:npix]'-1)*(npix+1)+1 )=-4;

figure;
imagesc(L2); colorbar;



























